<?php
namespace FiloBlu\Rma\Plugin;
use Magento\Sales\Api\Data\OrderExtensionFactory;

class OrderGet
{

    /**
     * OrderGet constructor.
     * @param OrderExtensionFactory $orderExtensionFactory
     */
    public function __construct(OrderExtensionFactory $orderExtensionFactory) {
        $this->orderExtensionFactory = $orderExtensionFactory;
    }


    /**
     * @param \Magento\Sales\Api\Data\OrderInterface $order
     * @return \Magento\Sales\Api\Data\OrderInterface
     */
    protected function getMspData(\Magento\Sales\Api\Data\OrderInterface $order)
    {
        $extensionAttributes = $order->getExtensionAttributes();
        if ($extensionAttributes && $extensionAttributes->getPaymentFeeAmount()) {
            return $order;
        }
        if($order->getPayment()->getMethod() != \FiloBlu\Rma\Model\Payment\ChangeSizePay::PAYMENT_CODE){
            return $order;
        }
        /** @var \Magento\Sales\Api\Data\OrderExtension $orderExtension */
        $orderExtension = $extensionAttributes ? $extensionAttributes : $this->orderExtensionFactory->create();
        $orderExtension->setPaymentFeeAmount(floatval($order->getMspCodAmount())-floatval($order->getMspCodTaxAmount()));
        $orderExtension->setBasePaymentFeeAmount(floatval($order->getBaseMspCodAmount())-floatval($order->getBaseMspCodTaxAmount()));
        $orderExtension->setPaymentTaxAmount(floatval($order->getMspCodTaxAmount()));
        $orderExtension->setBasePaymentTaxAmount(floatval($order->getBaseMspCodTaxAmount()));
        $order->setExtensionAttributes($orderExtension);

        return $order;
    }
}